#!/bin/bash

#
# PurpleDrake Lite root for LG G3 - BASH version
# - A collaboration between autoprime (@utoprime), iomonster (@tylerfixer or thecubed on XDA), and jcase (@teamandirc)
#  
# This application does not cost money. If someone has charged you money for it, you have been ripped off.
# 
# This script was written by IOMonster
#



# Function definitions here

ADBPATH=$1

# Pause script and wait for user input
function pause() {
   read -p "Press [enter] to continue..."
}

# From http://stackoverflow.com/a/8574392
function containsElement() {
	local e
	for e in "${@:2}"; do [[ "$e" == "$1" ]] && return 0; done
	return 1
}

# Override adb shell, so I can make this script for OSX/Linux/Windows with just a parameter change!
function adbshell() {
	$ADBPATH/adb shell "$*"
	#adb shell "$*"
}

# Override adb itself too, heh
function adbfun() {
	$ADBPATH/adb $*
	#adb $*
}

# wouldn't you guess, but wait-for-device is broken for recovery...
function adbwait() {
	echo -n "Waiting for device... "
	ADB_NEEDS_RESTART=1
	until [ "$(adbfun shell "echo -n PONG" 2> /dev/null)" == "PONG" ]; do
		# if darwin, cycle adbd until you get a device
		if [[ $OSTYPE =~ "darwin" ]]; then
			# prevent darwin from cycling adbd after we've had a successful device find, the server is good for now.
			if [ "x$ADB_NEEDS_RESTART" == "x1" ]; then
				adbfun "kill-server" 2>&1 > /dev/null
				adbfun "start-server" 2>&1 > /dev/null
			fi
			echo -n "."
			sleep 3
		else
			echo -n "."
			sleep 2
		fi
	done
	# keep us from cycling the server on OSX over and over 
	ADB_NEEDS_RESTART=0
	echo -ne ' Found device! \n'
}

function prepare_and_temproot() {
	echo -e "\nRebooting phone..."
	
	# first, reboot to the vulnerable mode
	adbfun "reboot --bnr_recovery"
	
	# now let's wait for the device
	adbwait
	
	echo "Found device, checking if vulnerable..."
	
	# check if we've got the vunerable application running
	VULN=$(adbshell 'ps | grep brd > /dev/null 2>&1; echo -n $?')
	if [ "x$VULN" != "x0" ]; then
		echo -e "\n\033[1;31mERROR:\033[0m Your phone is not running a compatible software version. No vulnerable mode detected, rebooting phone."
		adbfun "reboot"
		return 1
	fi
	
	echo "Yep, performing temproot..."
	
	# Push our config file, then the actual root
	adbfun push ./assets/start_restore /temp/start_restore > /dev/null 2>&1
	adbfun push ./assets/temproot.bin /temp/start_restore > /dev/null 2>&1
	
	# let it do it's thing...
	echo "Waiting for system to settle..."
	sleep 3
	
	# check if it worked?
	VULN2=$(adbshell 'ls /temp/fakesu > /dev/null 2>&1; echo -n $?')
	if [ "x$VULN2" != "x0" ]; then
		echo -e "\n\033[1;31mERROR:\033[0m Something went wrong. FakeSU didn't work, rebooting phone."
		echo "Debug information - 'ls -l /temp/fakesu': "
		adbshell 'ls -l /temp/fakesu'
		echo "------------------------"
		adbfun "reboot"
		return 1
	fi
	
	echo "Temproot worked, all done here. Moving on..."
	
	# we have a winner!
	return 0
}

function permaroot() {
	
	# now let's wait for the device (technically, the device should be available, but you never know. User could have unplugged it!)
	adbwait
	
	echo -e "\nApplying permaroot..."
	
	# needs a few seconds to settle, finding that doing these one right after another breaks it..
	sleep 7
	
	# we're already in vulnerable mode, push our payload, no need for config file.
	#adbfun push ./assets/start_restore /temp/start_restore > /dev/null 2>&1
	adbfun push ./assets/permaroot.bin /temp/start_restore > /dev/null 2>&1
	
	# let it do it's thing...
	echo "Waiting for system to settle..."
	sleep 3
	
	echo "Checking if it worked..."
	
	# check if it worked?
	VULN=$(adbshell 'ls /system/xbin/su > /dev/null 2>&1; echo -n $?')
	if [ "x$VULN" != "x0" ]; then
		echo -e "\n\033[1;31mERROR:\033[0m Something went wrong. Permaroot doesn't appear to have worked, rebooting phone."
		echo "Debug information - 'ls -l /system/xbin/su': "
		adbshell 'ls -l /system/xbin/su'
		echo "------------------------"
		echo "Debug information - 'ls -l /temp/': "
		adbshell 'ls -l /temp/'
		echo "------------------------"
		adbfun "reboot"
		return 1
	fi
	
	echo "Permaroot worked, all done here. Moving on..."
	
	# we have another winner!
	return 0
	
}


##
## MAIN PROGRAM BEGINS HERE
##

echo -e 'Welcome to \033[35mPurpleDrake\033[0m!\n'

echo "Please ensure your phone is connected, powered on, and USB debugging is properly enabled."
echo "Your phone should be showing your homescreen with no other apps open. This is to ensure a clean state."
echo -e "When you're ready, press [enter]...\n"
pause

# wait for the phone, ensuring user hasn't pressed enter without a phone connected (silly user!)
adbwait

# get phone infos
PHONE_MODEL=$(adbshell "getprop ro.product.model" | tr -d '\r\n')
PHONE_CARRIER=$(adbshell getprop "ro.build.target_operator" | tr -d '\r\n')
PHONE_SWVERS=$(adbshell getprop "ro.lge.swversion_short" | tr -d '\r\n')

echo -e "\n\nYour phone is a \033[35m[ ${PHONE_MODEL} ]\033[0m on \033[35m[ ${PHONE_CARRIER} ]\033[0m running SW version \033[35m[ ${PHONE_SWVERS} ]\033[0m ...\n\n"

# alright, let's get started.
echo "Alright. We're ready to go. We're going to temproot your phone first. Press enter when you're ready!"
pause

# temproot us!
prepare_and_temproot
RET=$?
if [ $RET != 0 ]; then
	echo "We tried to temproot you, and it didn't work. This phone isn't vulnerable, it would appear."
	echo "Please post on XDA with your phone model, carrier, and SW version in the PurpleDrake thread and someone will take a look."
	echo 'Your phone has been rebooted back to normal system mode, no changes have been made. Thanks for trying!'
	adbfun "kill-server" 2>&1 > /dev/null
	exit 1
fi

# check and see if the user just wants temproot
echo -e "Alright, now that you're temprooted, you can press CTRL-C here and get \na temproot prompt through 'adb shell /temp/fakesu' if you're so inclined..."
echo "However, if you'd like to permaroot, let's continue."
pause

permaroot
RET=$?
if [ $RET != 0 ]; then
	echo "So, we temprooted your phone, but we weren't able to permaroot it for some reason."
	echo "Please post on XDA with your phone model, carrier, and SW version in the PurpleDrake thread and someone will take a look."
	echo 'Your phone has been rebooted back to normal system mode, no changes have been made. Thanks for trying!'
	adbfun "kill-server" 2>&1 > /dev/null
	exit 2
fi


echo 'All done! Your phone has been successfully rooted.'
echo -e "After you press enter, your phone will be rebooted back to a rooted system. \nPlease be careful with what you change."
pause
adbfun "reboot"
adbfun "kill-server" 2>&1 > /dev/null
exit 0

	
